/***************************************************************************
                          gifdecode.cpp  -  description
                             -------------------
    begin                : Fri May 26 2000
    copyright            : (C) 2000 by Helmut Fahrion
    email                : hefa@bitctrl.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// Gif Objekt
#include "gifdecode.h"

// construtor
gifdecode::gifdecode ()
{
  (void *) GifFile = (void *) lk = (void *) ls = verbose = 0;
}

// Gif anzeigen
void
gifdecode::showgif (void *wdg, void *win)
{
  gifblock *p;

  // Zeichnet Hintergrund fr Transparente Images
  imagedesc bgi (w, h);
  bgi.userbg (wdg, 1);		// Hintergrund zeichnen

  if (!loop)
    loop = 1;			// Paintevent soll wenigestens nochmal zeichnen

  // Gif Application Loop 
  while (loop)
    {
      // hole Zeiger auf Gifblockliste   
      for (p = lk; p; p = (gifblock *) p->getnext ())
	{
	  //usleep(100000L);
	  //cout << "draw = " << p << "\n";
	  if (pict)		// Einzelbildanzeige
	    {
	      if (p->getnr () == pict)
		{
		  // nochmal ohne Disposal zeichnen
		  int odm;
		  graphicsblock *gbv;

		  gbv = (graphicsblock *) p->getprev ();
		  odm = gbv->dm;
		  gbv->dm = 0;	// mus 0 gesetzt werden sonst kann es eine Schleife geben

		  p->draw (wdg, win);
		  gbv->dm = odm;

		  if (verbose)
		    cout << "Picture = " << pict << "\n";

		  // raus aus schleifen  
		  loop = 1;
		  break;
		}
	    }
	  else
	    p->draw (wdg, win);
	}

      if (!eloop)
	loop--;
    }
}

// construtor
gifdecode::gifdecode (char *GifFileName, char verb, unsigned int nt,
		      unsigned int picture, char el)
{
  int ExtCode;
  char sb;
  GifRecordType RecType;
  GifByteType *Extension;
  gifblock *previmg, *txtbesch;

  verbose = verb;
  loop = 1;

  eloop = el;			// endlosschleife

  newtime = nt;
  pict = picture;

  (void *) previmg = (void *) txtbesch = (void *) gcontrol = NULL;

  try
  {

    if ((GifFile = DGifOpenFileName (GifFileName)) == NULL)
      {
	throw (1);
      }

    /* werden Window w und h */
    w = GifFile->SWidth;
    h = GifFile->SHeight;

    lk = ls =
      new screenblock (NULL, GifFileName, GifFile->SWidth, GifFile->SHeight,
		       GifFile->SColorResolution, GifFile->SBackGroundColor,
		       GifFile->SColorMap);
    if (!lk)
      throw (-1);

    if (verbose)
      cout << "\n" << ((screenblock *) lk);

    do
      {
	if (verbose)
	  cout << "Read DGifGetRecordType!\n";

	if (DGifGetRecordType (GifFile, &RecType) == GIF_ERROR)
	  {
	    //cerr << "Fehler  DGifGetRecordType !\n";
	    throw (1);
	  }

	switch (RecType)
	  {
	  case IMAGE_DESC_RECORD_TYPE:

	    if (verbose)
	      cout << "IMAGE_DESC_RECORD_TYPE!\n";

	    if (DGifGetImageDesc (GifFile) == GIF_ERROR)
	      throw (1);

	    // auch vorheriges img speichern, fr Disposalmehtod 3  
	    previmg = ls =
	      new imagedesc (ls, lk, previmg, gcontrol, verbose, GifFile);

	    if (!ls)
	      throw (-1);
	    if (verbose)
	      cout << "\n" << ((imagedesc *) ls);

	    if (verbose == 2)
	      ((imagedesc *) ls)->printpixelblock ();

	    break;

	  case EXTENSION_RECORD_TYPE:
	    if (verbose)
	      printf ("EXTENSION_RECORD_TYPE! ");

	    if (DGifGetExtension (GifFile, &ExtCode, &Extension) == GIF_ERROR)
	      throw (1);

	    if (verbose)
	      cout.form (" (Ext Code = %d [%c]):\n", ExtCode,
			 MAKE_PRINTABLE (ExtCode));

	    sb = 0;		// Subblock = 0 = Anfang  
	    do
	      {
		switch (ExtCode)
		  {
		  case COMMENT_EXT_FUNC_CODE:
		    if (verbose)
		      cout << "GIF89 comment\n";
		    ls = new commentblock (ls, Extension);
		    if (!ls)
		      throw (-1);
		    if (verbose)
		      cout << "\n" << ((commentblock *) ls);
		    break;
		  case GRAPHICS_EXT_FUNC_CODE:
		    if (verbose)
		      cout << "GIF89 graphics control\n";
		    gcontrol = ls =
		      new graphicsblock (ls, newtime, Extension);
		    if (!ls)
		      throw (-1);
		    if (verbose)
		      cout << "\n" << ((graphicsblock *) ls);
		    break;
		  case PLAINTEXT_EXT_FUNC_CODE:
		    // auf einen Beschreibungsblock folgt ein
		    // Textblock mit dem Text als Inhalt    
		    if (verbose)
		      {
			cout << "GIF89 Plaintext:\n";
		      }
		    if (!sb)
		      {
			txtbesch = ls = new ptextblock (ls, lk, Extension);
			if (!ls)
			  throw (-1);
			if (verbose)
			  cout << "\n" << ((ptextblock *) ls);
		      }
		    else
		      {
			ls = new pstrblock (ls, txtbesch, Extension);
			if (!ls)
			  throw (-1);
			if (verbose)
			  cout << "\n" << ((pstrblock *) ls);
		      }
		    sb = sb ? 0 : 1;
		    break;
		  case APPLICATION_EXT_FUNC_CODE:
		    if (verbose)
		      cout << "GIF89 application block\n";
		    ls = new appblock (ls, Extension);
		    if (!ls)
		      throw (-1);

		    if (verbose)
		      cout << "\n" << ((appblock *) ls);

		    if (((appblock *) ls)->isloop ())
		      loop = ((appblock *) ls)->isloop ();
		    break;
		  default:
		    if (verbose)
		      cout << "Extension record of unknown type!\n";
		    break;
		  }

		if (DGifGetExtensionNext (GifFile, &Extension) == GIF_ERROR)
		  throw (1);
	      }
	    while (Extension);

	    break;

	    // sollte schon am Anfang der Datei gekommen sein  
	  case SCREEN_DESC_RECORD_TYPE:
	    if (verbose)
	      cout << "ScreenDescRecordType!\n";
	    break;

	  case TERMINATE_RECORD_TYPE:
	    if (verbose)
	      cout << "TERMINATE_RECORD_TYPE!\n";
	    break;
	  default:
	    break;
	  }
      }
    while (RecType != TERMINATE_RECORD_TYPE);
  }

  catch (int i)
  {
    if (i == -1)
      cerr << "Kein Speicher fr neues Objekt frei!\n";

    if (i == 1)
      {
	PrintGifError ();
	// ?????????????????? 
	exit (-1);
      }
  }
}

// destructor
gifdecode::~gifdecode ()
{
  // File wieder schlieen
  // DGifCloseFile(GifFile);
  if (DGifCloseFile (GifFile) == GIF_ERROR)
    {
      PrintGifError ();
      exit (-1);
    }

  delete lk;

  lk = ls = NULL;
}
